/****************************
 * DreamShell ##version##   *
 * console.h                *
 * DreamShell console       *
 * Created by SWAT          *
 * http://www.dc-swat.net.ru*
 ***************************/


#ifndef _DS_CONSOLE_H
#define _DS_CONSOLE_H

#include "video.h"



typedef enum {
	CMD_OK = 0,			/* 0 */
	CMD_NO_ARG,         /* 1 */
	CMD_ERROR,		    /* 2 */
	CMD_NOT_EXISTS		/* 3 */
} CMD_RESULT;


typedef int CmdHandler(int, char *[]);

typedef struct Cmd {

	const char *command;
	const char *desc;
	CmdHandler *handler;
	
} Cmd_t;



int CallCmd(int argc, char *argv[]);  

Cmd_t *AddCmd(const char *cmd, const char *helpmsg, CmdHandler *handler);
void RemoveCmd(Cmd_t *cmd);

Item_list_t *GetCmdList();
Cmd_t *GetCmdByName(const char *name);

int InitCmd(); 
void ShutdownCmd();





char *SetConsoleStdout(char *buff);
void SetConsoleDebug(int mode);

int ds_printf(const char *fmt, ...); 
int ds_uprintf(const char *fmt, ...);
int dbg_printf(const char *fmt, ...);


int dsystem(const char *buff); 
int dsystemf(const char *fmt, ...);
int dsystem_script(const char *fn, char *argv[]);


int InitConsole(const char *font, const char *background, int lines, int x, int y, int w, int h, int alpha);
void ShutdownConsole();

void DrawConsole();
int ToggleConsole();
void ShowConsole();
void HideConsole();
ConsoleInformation *GetConsole();


void VKB_Init();
void VKB_Shutdown();
void ToggleVKB();


#endif
