/****************************
 * DreamShell ##version##   *
 * gui.h                    *
 * DreamShell GUI           *
 * Created by SWAT          *
 ****************************/ 

#ifndef _DS_GUI_H
#define _DS_GUI_H


#include "ds.h"
#include "SDL_gui.h"



typedef struct MouseCursor {
    
    SDL_Surface *bg;
    SDL_Surface *cursor;
    SDL_Rect src, dst;
    int draw;

} MouseCursor_t;


/*
  Create cursor from file or surface.
*/
MouseCursor_t *CreateMouseCursor(char *fn, SDL_Surface *surface);
void DestroyMouseCursor(MouseCursor_t *c);
void DrawMouseCursor(MouseCursor_t *c, SDL_Event *event);
void SetActiveMouseCursor(MouseCursor_t *c);
MouseCursor_t *GetActiveMouseCursor();


int InitGUI();
void ShutdownGUI();

int LockGUI();
int UnLockGUI();

Uint32 colorHexToRGB(char *color, SDL_Color *clr);
SDL_Color Uint32ToColor(Uint32 c);
Uint32 ColorToUint32(SDL_Color c);
Uint32 MapHexColor(char *color, SDL_PixelFormat *format);


#endif
