/****************************
 * DreamShell ##version##   *
 * list.h                   *
 * List manager             *
 * Created by SWAT          *
 ****************************/ 

#ifndef _DS_LIST_H
#define _DS_LIST_H


#include <kos.h>
#include <stdlib.h>


//   

typedef struct Item {

        //   SLIST,    .
        SLIST_ENTRY(Item) list; 
        
        //   
        const char *name;
        
        // ID  
        int id;
        
        //   
        int type;
        
        //   
        void *data;
   
} Item_t;


//    ,  SLIST   newlib 
typedef SLIST_HEAD(ItemList, Item) Item_list_t;

//   ,  ,   .
typedef void listFreeItemFunc(void *);


/*
	   ,    DreamShell,    . 
	   ,          , 
	      LIST_ITEM_USERDATA.
*/

#define LIST_ITEM_USERDATA 0
#define LIST_ITEM_SDL_SURFACE 1

#define LIST_ITEM_GUI_SURFACE 2
#define LIST_ITEM_GUI_FONT 3
#define LIST_ITEM_GUI_WIDGET 4

#define LIST_ITEM_MODULE 5
#define LIST_ITEM_APP 6
#define LIST_ITEM_EVENT 7
#define LIST_ITEM_THREAD 8
#define LIST_ITEM_CMD 9
	
	

//       .  NULL    .
Item_list_t *listMake();

/* 
	      ,  ifree  ,   ,    .
	    free,      ,     ifree - NULL
*/
void listDestroy(Item_list_t *lst, listFreeItemFunc *ifree);


//  ID   (   )  .
int listGetLastId(Item_list_t *lst);

//           ,     NULL.
Item_t *listAddItem(Item_list_t *lst, int type, const char *name, void *data);

//    .
void listRemoveItem(Item_list_t *lst, Item_t *i, listFreeItemFunc *ifree);

/* 
          . 
      ,    ,   ,   NULL.
*/
Item_t *listGetItemByName(Item_list_t *lst, const char *name);

/* 
         ID. 
     ,    ,   ,   NULL.
*/
Item_t *listGetItemById(Item_list_t *lst, int id);

//    .
Item_t *listGetItemFirst(Item_list_t *lst);

//    ,      i.
Item_t *listGetItemNext(Item_t *i);

/*
	:	
	 listGetItemFirst  listGetItemNext      .
*/


#endif
