/****************************
 * DreamShell ##version##   *
 * net.h                    *
 * DreamShell NET           *
 * Created by SWAT          *
 ****************************/     

#ifndef _DS_NET_H
#define _DS_NET_H



#ifdef DS_ARCH_DC

#include <sys/cdefs.h>
#include <arch/types.h>
#include <kos/net.h>
#include <lwip/lwip.h>
#include <lwip/lwip_ds.h>
#include <lwip/sockets.h>
/*
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
*/

#elif DS_ARCH_PSP

#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>
#include <sys/fd_set.h>



#else

#include <winsock.h>


#endif






#ifdef DS_ARCH_DC

/***   General network stuff   ***/


#define NET_CONNECTION_DIALUP 0
#define NET_CONNECTION_ETHERNET 1

#define DSNET_CLIENT 0
#define DSNET_SERVER 1

typedef struct DSNet {
        
  SLIST_ENTRY(DSNet)	list;
  
  vfs_handler_t vfs;
  
  char *name;
  char *host;
  char *path;
  int type;
  int port;
  
} DSNet_t;


typedef SLIST_HEAD(DSNet_list, DSNet) DSNet_list_t;


int net_dev_init();

int NetInit();
void NetShutdown();


int NetGetConnectionMode();
int NetIsConnected();
void NetSetConnected(int cond);


int SayToDSHome();


DSNet_t *CreateDSNet(char *name, char *path, int port);
int DestroyDSNet(char *name, DSNet_t *net);

DSNet_t *ConnectDSNet(char *host, int port);
int DosconnectDSNet(char *host, DSNet_t *net);

DSNet_t *GetDSNet(char *host, char *name); 
DSNet_list_t *GetDSNetList();



/***   Modem stuff   ***/

#define MODEM_CONNECT_PPP 0
#define MODEM_CONNECT_REMOTE 1
#define MODEM_CONNECT_ANSWER 2

int ModemPPP(char *prefix, char *number, char *user, char *pass, int tone);
int ModemAnswer();
int ModemRemote(char *prefix, char *number, int tone);
int ModemRemoteRaw();
int ModemDisconnect();


#endif

/***   Telnet client   ***/

int TelnetConnect(char *host, int port);
int TelnetDisconnect(int t);

int TelnetSend(int t, char *data, int size);
int TelnetRecv(int t, char *data, int size);




#ifdef DS_ARCH_DC

/***   httpd   ***/

int InitHttpd();
void ShutdownHttpd();



/***   telnetd   ***/

int InitTelnetd();
void ShutdownTelnetd();



/***   Filesystem   ***/

int tcpfs_init();
void tcpfs_shutdown();

int httpfs_init();
void httpfs_shutdown();


#endif

/***   Net utils   ***/

#define READIP(dst, src) \
        dst = ((src[0]) << 24) | \
                ((src[1]) << 16) | \
                ((src[2]) << 8) | \
                ((src[3]) << 0)
                
                
#define SETIP(target, src) \
	IP4_ADDR(target, \
		(src >> 24) & 0xff, \
		(src >> 16) & 0xff, \
		(src >> 8) & 0xff, \
		(src >> 0) & 0xff)
              
 

#ifdef DS_ARCH_DC 
                
int dns(const char *name, struct ip_addr *res);
//int ds_gethostbyname(const struct sockaddr_in * dnssrv, const char * name, uint8 * ipout);

void _url_split(char *proto, int proto_size,
               char *hostname, int hostname_size,
               int *port_ptr,
               char *path, int path_size,
               const char *url);

#endif



#endif
