/****************************
 * DreamShell ##version##   *
 * thread.h                 *
 * DreamShell treads        *
 * Created by SWAT          *
 ****************************/ 

#ifndef _DS_THREAD_H
#define _DS_THREAD_H


//#include "ds.h"

typedef void ThreadRoutine (void *);


typedef struct Thread {
	
#ifdef DS_ARCH_PSP
    SceUID thd;
#elif DS_ARCH_DC
    kthread_t *thd;
#else
    SDL_Thread *thd;
#endif
    
    const char *name;
    int id;
    
} Thread_t;



int InitThreads();
void ShutdownThreads();

Thread_t *CreateThread(ThreadRoutine *routine, void *param, const char *name);
int DestroyThread(Thread_t *p);

int SetThreadPrio(Thread_t *p, int prio);
void WaitThread(Thread_t *p);

Thread_t *GetThreadByName(const char *name);
Thread_t *GetThreadById(int id);
Item_list_t *GetThreadList(); 





typedef struct Sem {
        
#ifdef DS_ARCH_DC
    semaphore_t *event;
#elif DS_ARCH_PSP
    SceUID event;
#else
    SDL_mutex *event;
#endif
    
} Sem_t;


Sem_t *SemCreate();
int SemDestroy(Sem_t *s);
int SemWait(Sem_t *s);
int SemSignal(Sem_t *s);



#endif
