/****************************
 * DreamShell ##version##   *
 * utils.h                  *
 * DreamShell Utils          *
 * Created by SWAT          *
 ****************************/ 


#ifndef _DS_UTILS_H
#define _DS_UTILS_H

//#include "ds.h"


/* Macros for accessing/creating version codes */
#define DS_VER_MAJOR(v) ((v >> 16) & 0xff)
#define DS_VER_MINOR(v) ((v >> 8) & 0xff)
#define DS_VER_MICRO(v) ((v >> 0) & 0xff)
#define DS_MAKE_VER(MAJOR, MINOR, MICRO) \
	( (((MAJOR) & 0xff) << 16) \
	| (((MINOR) & 0xff) << 8) \
	| (((MICRO) & 0xff) << 0) )


void readstr(FILE *f, char *string);
int FileSize(char *fn);
int FileExists(char *fn);
int PeriphExists(char *name);

int makeabspath(char *buff, char *path, size_t size);
int makeabspath_wd(char *buff, char *path, char *dir, size_t size);
const char *relativeFilePath(const char *rel, const char *file);
int relativeFilePath_wb(char *buff, const char *rel, const char *file);

char *getFilePath(const char *file);
char *getAbsoluteFilePath(const char *file);

int ds_chdir(char *dir);
char *getcwd(char *buf, size_t size);

#ifdef DS_ARCH_DC
void arch_shutdown();

void scramble(char *src, char *dst);
void descramble(char *src, char *dst);

#endif
void ds_sleep(int ms);

int splitline(char **argv, int max, char *line);

int hex_to_int(char c);
char *strtolower(char *str);

#if !defined(DS_ARCH_DC) || !defined(DS_ARCH_PSP)
char *strsep(char **stringp, const char *delim);
#endif

char* substring(const char* str, size_t begin, size_t len);

#endif
